# A activity-based linear blending- Shared Control-
## Context

Welcome Stalker Pilots of Gitlab to my basic shared control demo.

To implement this method manually, several key variables need to be understood. The haptic device serves as the interface between the human and the robot, facilitating the exchange of position information. The intent recognition mechanism calculates the human's intended target by analyzing the direction and distance factors. Lastly, the authority level, determined by the human's activity, governs the balance between human and robot control.


## Installation
The code use the QP controller of Auctus  where you need to use the panda_torque_qp, the falcon haptic device and the Optitrack; Thus the installation procedure is explained here :
- [ ] [Panda QP workspace](https://gitlab.inria.fr/auctus-team/components/robots/panda/panda_qp_ws)
- [ ] [OptiTrack](https://gitlab.inria.fr/auctus-team/components/sensors/cameras/optitrack/optitrack_to_robot)


### FALCON Haptic



```

sudo apt-get install libusb-1.0.0-dev
git clone https://github.com/libnifalcon/libnifalcon.git
mkdir build
cd build
cmake -G "Unix Makefiles" ..
make
make install
roscd falcon
sudo cp udev_rules/99-udev-novint.rules /etc/udev/rules.d

```
You need to unplug and replug the device. You may also need to restart the OS.

## Architecture
In order to understand the code and change the variables :
Lets introduce the block diagram on how this code is composed of :
![Alt Text](Pictures/SC.drawio.png)
## Haptic Device $`x_{h}`$
The haptic device is used by the human to send a position to the robot.
We can either use the falcon or the omega 7 haptic device.
A ROS node is created for falcon where we subscribe to "/falcon/joystick" and get "falcon_joy_msg" as a message for the human position. To send force to the haptic device we can use "ros_falcon::falconForces cartesian_force_ms;"

The haptic position $\mathbf{x_{h}}$ sent by the human in the robot workspace is computed as :

$\mathbf{x_{h}} =   s_{t}(\mathbf{x_{p}}-\mathbf{x_{c}})+\mathbf{x_{i}}$

where $\mathbf{x_{i}}$ is the initial pose of the robot in the robot workspace, $\mathbf{x_{c}}$ is the center pose of the haptic device and $\mathbf{x_{p}}$ is the position of the haptic interface  in the haptic workspace at the current time. $s_{t}$ the transitional scaling factor.
In the code Version :

```cpp
HapticPosition[]= s_t *(falcon_joy_msg.axes[]) - xh_center[]) + xr_initial[];
```
\TO DO




## Intent Recognition $`x_{r}`$
For the robot to estimate where the human is going, we predict it by the distance between the robot-end effector and the object  plus velocity direction of the haptic device in the robot workspace. Thus, we formulate it as :

The dot product give us a value between -1 (direction is complete opposite to the object) and 1 (direction is completely straight toward the object) :

$`\mathbf{{p}_{dot}}=  \frac{1}{N} \sum_{j=1}^{N} \frac{\mathbf{{x_{o}-x}}}{||\mathbf{{x_{o}-x}}||} \frac{\mathbf{{\dot{x}_{h}}}} {||\mathbf{{\dot{x}_{h}}}||}`$

where $\mathbf{x}$ is the current position of the robot  and $\dot{x}_{h}$ is the haptic velocity direction and $\mathbf{x_{o}}$ are the objects on the table.

Then we transform it from [-1,1] to [0,1] so any angle more than 90 degrees is seen as opposite and not the right direction and given a value of 1. The more the direction is toward the targe, the lower the value :

$`
\mathbf{{p}_{dot}} = \begin{cases}
    1-\mathbf{{p}_{dot}} & \text{if } \mathbf{{p}_{dot}} \geq 0 \\
    1 & \text{if } x < 0
\end{cases}
`$

We calculate the distance in similar way where the value is 0 when it is close to the target and higher when it is far :

$`\mathbf{{p}_{dist}}= \frac{  \mathbf{x_{i}-x}}{d_{max}}`$

Then we sum both of the direction and distance terms in 1 equation with a equivalent factor:


$` \mathbf{{p}_{intent}}=0.5\mathbf{{p}_{dot}}+0.5\mathbf{{p}_{dist}}`$
Thus, the value of $  \mathbf{{p}_{t}}$ can range from 0 to 1, where 1 indicates that the robot and human are far and going in a different direction from any of the targets, 0 indicates that the human is coincident to the target and going in the direction of the target, and 0.5 indicates that the robot is far from the target or going away from the target at least.

Then the robot autonomous target will become :

$` \mathbf{x_{r}}=\mathit{min}(\mathbf{{p}_{intent}})`$

In the code Version :
```cpp
void IntentRecognition()
... TO DO
```
\ TO DO show the display of objects vs intent  as GIF
## Authority Level: $`B`$
Our method is a storing-tank technique that links the authority/blending factor to the human's activity. The activity level of the human is measured through its power generated by the haptic device and stores it in a the tank over time. The power of the human $P_{h}$ is represented can be represented by:
$` P_{h}= F_{h}\dot{x}_{h}`$

We can approximate $`F_{h}`$  by measuring the acceleration of the handler $`\ddot{x}_h`$  assuming that the gravity compensation is active, and the system being considered a unit mass .
Thus, power produced by the human is equivalent to:

  $`P_{h}= mass\Ddot{x}_{h}\dot{x}_{h}`$.
  where we can remove the mass.

We want to map the power produced by the human to a activity scale where we can design that if the human has full control over the robot, it is designed as 1 and if the human is not controlling the robot then the authority is null.

Thus several method can be done to go from the human power to an activity based authority level :

### Step Minimum power :
In this method, we assume that any minimum activity exerted by the human is perceived as an activity, and thus, the human retains instantaneous authority. We measure the minimum power that can be observed when the human intends to initiate motion. The authority level is computed as follows:

$`
/Beta_{in} = \begin{cases}
    1  & \text{if } P_{h} \geq P_{min} \\
    0 & \text{if } P_{h} < P_{min}
\end{cases}
`$
P_{min} can be determined experimentally through trial and error, estimating the slowest possible motion achievable by the human using the haptic device.
Then $/Beta_{in}$ is an input to a 1st-ODE function that can work as a tank where we calculate the authority level as in $`B`$  :

$`K_{t}\frac{dB}{dt}+K_{out}B= K_{in}B_{in}`$

The factor $K_{out}=1$ and $K_{in}=1$ so it limits the output with a value 1 as max.

In the code snipper, :
```cpp
void StepMinimumPower()
... TO DO
```

### Linear Global Power :
The idea here is to calculate $P_{max}$ and P_{min} and then calculate a level of activity $B$ that can be interpolated between these 2 values.
$`B_{in}= \frac{P-P_{min}}{P_{max}-P_{min}}`$

One approach is to calculate the mean power in order to estimate the average activity made by the human to do a specific motion and then we assume that that an average motion made by the human should be equivalent to $P_{max}$ :

$`P_{mean}=P_{max}=\frac{1}{t}\sum_{t=0}^{t=current}P_{h}`$

The mean power can also be calculated on a moving average which can depend on the task type the operator is trying to achieve.



The minimum power can be calculated by either trial and error like the previous one or it can be assumed to be a $\%$ of the average power.
Another idea is to calculate the maximum power as a way to estimate what is maximum possible power that can be applied by the human and this can be estimated by the estimated maximum acceleration and velocity. / TO DO which method to choose



In the code snipper, :
```cpp
void LinearGlobalMeanPower()
... TO DO
```

### EnergyBasedAuthority:
The idea here is to convert the power generated to energy with time:
$`E_{i}=\int^{t_{i}}_{t_{i-1}} P dt`$
Then we compare the current energy generated with the energy of the previous time-frame and we increase/decrease the authority level based on the energy difference :

$` /B_{in} = \begin{cases} /B+k_{t} & \text{if } E_{2} \geq E_{1} \\ /B+k_{t} & \text{if } E_{2} < E_{1} \end{cases} `$

\TO DO
### Results and comparison of each activity method

\TO DO


## Linear Blending: $`x_{d}`$:

In linear blending, the inputs from the human and robot are assigned weights which is calculated in the authority level part that determine their influence on the final control output. These weights are typically scalar values between 0 and 1, representing the relative importance  of each input.
The blending process works by multiplying each input by its corresponding weight and then summing them together. The resulting sum represents the combined control signal that drives the robot's actions:
$`x_{d}=Bx_{h}+(B-1)x_{r}`$


## PD motion: $`\dot{v}_{des}`$
The desired acceleration $`\dot{v}_{des}`$ is computed through a PD controller that takes as input, a desired blended position $`x_{d}`$  and the robot current pose $`x`$ and the currrent velocity as $`\dot{x}`$.

$` \dot{v}_{des} =k_{p}(x_{d}-x)+k_{d}(\dot{x})`$

To saturate the velocity, the equation is re-wrriten as :

To saturate and limit the velocity term in respect to the task constraints, we use $\mathbf{V}$ as a scaling factor and $\dot{x}_{max}$ as the maximum velocity limits given as :
    $`\mathbf{V}= min(1,\frac{\mathbf{\dot{x}_{max}}}{\sqrt{\mathbf{\dot{x}^2}}})`$

Then; $` \mathbf{x^{*}}= -\mathbf{K_{v}}(\mathbf{\dot{x}}-\mathbf{V}\mathbf{{\dot{x}^{*}}})) `$
Therefore the command acceleration to minimize in the QP is :
    $` \dot{v}_{des}- \frac{\mathbf{K_{p}}}{\mathbf{K_{v}}}(\mathbf{x}-\mathbf{x_{d}}) `$
